%define qtdir %{_libdir}/%{name}-%{version}
%define name qt
%define major 2
%define version 2.2.3
%define release 1mdk
%define type embedded

Summary: The shared library for the Qt GUI toolkit for framebuffer devices.
Name: %{name}%{major}-%{type}
Version: %{version}
Release: %{release}
Source: ftp://ftp.troll.no/qt/source/qt-%{type}-%{version}.tar.bz2
Patch0: qt-2.1.0-huge_val.patch.bz2
Patch201: qt-embedded-2.2.3-segfault.patch.bz2
Epoch: 1
URL: http://www.troll.no/
Copyright: GPL
Group: Development/KDE and QT
Buildroot: %{_tmppath}/%{name}-root
Prereq: /sbin/ldconfig
BuildRequires: gcc-c++, libstdc++, libstdc++-devel, libmng-devel, XFree86-devel, glibc-devel, libjpeg-devel, libpng-devel, zlib-devel, libungif-devel

%description
Qt is a GUI software toolkit which simplifies the task of writing and
maintaining GUI (Graphical User Interface) applications for framebuffer devices.
It is meant primarily to run on embedded devices (handhelds), but can
be used to run graphical applications without using the X Window
System on "normal" computers, as well.
This version of qt-embedded has been compiled with the full feature
set (and memory usage). If you are developing software for an
embedded device with little RAM, you will probably want to recompile
it with a custom feature set.

Qt is written in C++ and is fully object-oriented.

This package contains the shared library needed to run %{name}
applications, as well as the README files for %{name}.

%package -n lib%{name}
Summary:        Shared library for the Qt2 embedded toolkit
Group:          Development/KDE and QT
Provides:       %{name}
Obsoletes:      %{name}
%description -n lib%{name}
Qt is a GUI software toolkit. Qt simplifies the task of writing and maintaining
GUI (graphical user interface) applications for framebuffer devices.
Qt is written in C++ and is fully object-oriented. It has everything you need
to create professional GUI applications. And it enables you to create them
quickly.

Qt is a multi-platform toolkit. When developing software with Qt, you can run
it on the X Window System (Unix/X11) or Microsoft Windows NT and Windows 95/98
or framebuffer devices.
Simply recompile your source code on the platform you want.

This package contains the shared library needed to run Qt2 applications, as
well as the README files for Qt.


%package -n lib%{name}-devel
Summary: Development files and documentation for the Qt GUI toolkit for framebuffer devices.
Group: Development/KDE and QT
Requires: %{name} = %{version}-%{release}

%package static
Summary: Version of the Qt GUI toolkit for framebuffer devices for static linking
Group: Development/KDE and QT
Requires: %{name}-devel = %{version}-%{release}

%package designer
Summary: Interface designer (IDE) for the Qt toolkit for framebuffer devices
Group: Development/KDE and QT
Requires: lib%{name}-devel = %{version}-%{release}

%description -n lib%{name}-devel
The %{name}-devel package contains the files necessary to develop
applications using the Qt GUI toolkit: the header files, the Qt meta
object compiler, the man pages, the HTML documentation and example
programs.  See http://www.trolltech.com/products/qt.html for more
information about Qt, or look at
%{_docdir}/%{name}-devel-%{version}/html/index.html, which
provides Qt documentation in HTML format.

Install %{name}-devel if you want to develop GUI applications using the Qt
toolkit for framebuffer devices.

%description static
The %{name}-static package contains the files necessary to link applications
to the %{name} GUI toolkit statically (rather than dynamically).
Statically linked applications don't require the library to be installed
on the system running the application.

%description designer
The %{name}-designer package contains an User Interface designer tool
for the Qt toolkit.

%prep
%setup -q -n qt-%{version}
[ -f Makefile.cvs ] && make -f Makefile.cvs # this is for qt-copy in KDE CVS
    rm -rf tools/designer/examples
%patch0 -p0 -b .hugeval
%patch201 -p1 -b .segfault

%build
find . -type d -name CVS | xargs rm -rf
export QTDIR=`/bin/pwd`
OPTFLAGS=`echo $RPM_OPT_FLAGS |sed -e s/-fno-rtti//`

perl -pi -e "s/-O2/$OPTFLAGS -fno-exceptions/g" configs/linux* configs/gnu* configs/freebsd*

if [ -x /usr/bin/getconf ] ; then
    NRPROC=$(/usr/bin/getconf _NPROCESSORS_ONLN)
    if [ $NRPROC -eq 0 ] ; then
   NRPROC=1
    fi
else
    NRPROC=1
fi

# build static libraries first,
# don't build examples, tools and tutorials with static libraries here
./configure -release -static -gif -no-sm -thread -system-zlib \
	-system-libpng -system-libmng -system-jpeg -no-g++-exceptions \
	-accel-voodoo3 -accel-mach64 -accel-matrox <<EOF
yes
5
v,4,8,16,24,32
EOF

make src-moc src-mt sub-src sub-tools -j $NRPROC

# build shared libraries
./configure -release -shared -gif -no-sm -thread -system-zlib \
        -system-libpng -system-libmng -system-jpeg -no-g++-exceptions \
        -accel-voodoo3 -accel-mach64 -accel-matrox <<EOF
yes
5
v,4,8,16,24,32
EOF

make src-moc src-mt sub-src sub-tools -j $NRPROC
make -C tools/designer -j $NRPROC

%install
rm -rf $RPM_BUILD_ROOT
export QTDIR=`/bin/pwd`

mkdir -p $RPM_BUILD_ROOT%{_libdir}/%{name}-%{version}/{bin,include,lib}
mkdir -p $RPM_BUILD_ROOT%{_mandir}/{man1,man3}

# strip binaries
for i in bin/*; do
  strip -R .comment $i || :
done

# install shared and static libraries
install -m 755 bin/* $RPM_BUILD_ROOT%{_libdir}/%{name}-%{version}/bin
install -m 755 lib/* $RPM_BUILD_ROOT%{_libdir}/%{name}-%{version}/lib

ln -sf libqutil.so.1.0.0 $RPM_BUILD_ROOT%{_libdir}/%{name}-%{version}/lib/libqutil.so.1.0
ln -sf libqutil.so.1.0.0 $RPM_BUILD_ROOT%{_libdir}/%{name}-%{version}/lib/libqutil.so.1
ln -sf libqutil.so.1.0.0 $RPM_BUILD_ROOT%{_libdir}/%{name}-%{version}/lib/libqutil.so

# install man pages
cp -fR src/moc/moc.1 $RPM_BUILD_ROOT%{_mandir}/man1
cp -fR doc/man/man3/* $RPM_BUILD_ROOT%{_mandir}/man3
rm -rf doc/man

# Compensate for Qt's broken Makefiles
for i in makeqpf mergetr msg2qm qconfig; do
	make -C tools/$i
	strip -R .comment tools/$i/$i
	install -m 755 tools/$i/$i $RPM_BUILD_ROOT%{_libdir}/%{name}-%{version}/bin
done

# clean up
make -C tutorial clean
make -C examples clean
find examples -name Makefile | xargs perl -pi -e 's|\.\./\.\.|\$\(QTDIR\)|'
find examples -type f -perm 755 | xargs strip -R .comment || :
find tutorial -name Makefile | xargs perl -pi -e 's|\.\./\.\.|\$\(QTDIR\)|'
find tutorial -type f -perm 755 | xargs strip -R .comment || :

for a in */*/Makefile ; do
  sed 's|^SYSCONF_MOC.*|SYSCONF_MOC		= %{qtdir}/bin/moc|' < $a > ${a}.2
  mv -v ${a}.2 $a
done

rm -f include/qt_mac.h include/qt_windows.h
rm -f include/jri.h include/jritypes.h include/npapi.h include/npupp.h

cp -frL include/. $RPM_BUILD_ROOT%{qtdir}/include || \
	cp -fr include/. $RPM_BUILD_ROOT%{qtdir}/include
chmod -R a+r $RPM_BUILD_ROOT%{qtdir}/lib/libqte.so*

cp -aR etc $RPM_BUILD_ROOT%{qtdir}

mkdir -p $RPM_BUILD_ROOT/etc/profile.d
cat > $RPM_BUILD_ROOT/etc/profile.d/qt.sh <<EOF
# Qt initialization script (sh)
if [ -z "\$QTDIR" ] ; then
	QTDIR="%{qtdir}"
fi
export QTDIR
EOF

chmod 755 $RPM_BUILD_ROOT/etc/profile.d/qt.sh

cat > $RPM_BUILD_ROOT/etc/profile.d/qt.csh <<EOF
# Qt initialization script (csh)
if ( \$?QTDIR ) then
         exit
endif
setenv QTDIR %{qtdir}
EOF

chmod 755 $RPM_BUILD_ROOT/etc/profile.d/qt.csh

mkdir -p $RPM_BUILD_ROOT/usr/bin
for i in moc uic designer makeqpf mergetr msg2qm qconfig qt20fix qtrename140 findtr; do
	ln -sf ../lib/%{name}-%{version}/bin/$i $RPM_BUILD_ROOT/usr/bin/$i-%{type}
done

# make symbolic link to qt docdir
if echo %{_docdir} | grep  share >& /dev/null ; then
  ln -s  ../../share/doc/%{name}-devel-%{version} $RPM_BUILD_ROOT%{qtdir}/doc
else
  ln -s  ../../doc/%{name}-devel-%{version} $RPM_BUILD_ROOT%{qtdir}/doc
fi

%clean
rm -rf $RPM_BUILD_ROOT

%post -n lib%{name} -p /sbin/ldconfig

%post -n lib%{name}-devel -p /sbin/ldconfig

%postun -n lib%{name} -p /sbin/ldconfig

%postun -n lib%{name}-devel -p /sbin/ldconfig



%files -n lib%{name}
%defattr(-,root,root,-)
%doc README* changes*
%dir %{qtdir}
%dir %{qtdir}/lib
%{qtdir}/lib/libqte.so.*
%{qtdir}/lib/libqte-mt.so.*
%{qtdir}/lib/libqutil.so.*
%dir %{qtdir}/etc
%dir %{qtdir}/etc/dict
%dir %{qtdir}/etc/fonts
%dir %{qtdir}/etc/qimpen
%dir %{qtdir}/etc/sounds
%{qtdir}/etc/dict/*
%{qtdir}/etc/fonts/*
%{qtdir}/etc/qimpen/*
%{qtdir}/etc/sounds/*

%files -n lib%{name}-devel
%defattr(-,root,root,-)
%{qtdir}/bin/moc
%{qtdir}/bin/uic
%{qtdir}/bin/findtr
%{qtdir}/bin/qt20fix
%{qtdir}/bin/qtrename140
%{qtdir}/bin/makeqpf
%{qtdir}/bin/mergetr
%{qtdir}/bin/msg2qm
%{qtdir}/bin/qconfig
%{qtdir}/include
%{qtdir}/doc
%{qtdir}/lib/libqte.so
%{qtdir}/lib/libqte-mt.so
%{qtdir}/lib/libqutil.so
%{_mandir}/*/*
%{_bindir}/moc*
%{_bindir}/uic*
%{_bindir}/findtr*
%{_bindir}/qt20fix*
%{_bindir}/qtrename140*
%{_bindir}/makeqpf*
%{_bindir}/mergetr*
%{_bindir}/msg2qm*
%{_bindir}/qconfig*

%doc doc/*
%doc examples
%doc tutorial

%files static
%defattr(-,root,root,-)
%{qtdir}/lib/*.a

%files designer
%defattr(-,root,root,-)
%{_bindir}/designer*
%{qtdir}/bin/designer

%changelog
* Sat Mar  3 2001  Daouda Lo <daouda@mandrakesoft.com> 2.2.4-1mdk
- first mdk release 


